/*
  EESIM.C
  Uses FLASH to store a structure
  Store all non-volatile data in a structure that you need
  on power on. Size limit using this code is 1K.
*/

#include "EEsim.h"

void * pv2;
char *cptr2;
char *cptr_orig2;
long ll;
char res2 = 0;

void EEsim_Init(void)
{
  FLASH_Erase(BASE_ADDR);  // setup 1K FLASH
}

/*
  write data to FLASH
  copy chunks of STRUCT into FLASH.
  arguments:
  char* cc : pointer to start of STRUCT
  int numbytes ; sizeof(struct) in bytes
*/
void EEsim_Write(char* cc, int numbytes)
{
  asm nop;
  asm nop;
  // FLASH_Write_Compact writes 128 chunks at a time, so break up
  // into 8 writes
  ll = BASE_ADDR;
  for(res2=0;res2<8;res2++)                   // 8 writes
  {
      FLASH_Write_Compact(ll,cc);             //chunk
      cc += 128; ll+=128;                     // inc ptr
      asm nop;                                // debug
  }
  asm nop;
}

void EEsim_Read(char* cc)
{
  asm nop;
  asm nop;
  // FLASH_Read_Compact reads 128 chunks at a time, so break up
  // into 8 reads
  ll = BASE_ADDR;
  for(res2=0;res2<8;res2++)                   // 8 writes
  {
      FLASH_Read_Compact(ll,cc,192);          //192 byte chunk
      cc += 128; ll+=128;                     // inc ptr
      asm nop;                                // debug
  }
  asm nop;
}