/*
        EEsim.h
        
        uses top 1K of a 256K device to store a STRUCT.
        Up to you to be sure STRUCT doesn't go over 1K.
        
        To change FLASH address for 128K / 64K devices,
        adjust BASE_ADDR. Read help for FLASH library -
        ADDR must be divisble by 1024 (bottom 10 bits are 0)

        example struct:
        struct T{
          long a;
          long aa;
          long aaa;
          int p;
          int pp;
          int ppp;
          char ary[100];
        };
        struct T test;

        USEAGE: Pass pointer to the struct to the Write/Read routines

        void * pv1;

        example Write:
        pv1 = &test;
        EEsim_Write(pv1,sizeof test);

        example Read:
        pv1 = &test;
        EEsim_Read(pv1);

*/

#define BASE_ADDR       0x002A800         // top 1K of dsPIC33 (256k)
//#define BASE_ADDR       0x0015400       // top 1K of dsPIC33 (128k)
//#define BASE_ADDR       0x000A800       // top 1K of dsPIC33 (64k)

void EEsim_Init(void);                    // init
void EEsim_Write(char*, int);             // Write STRUCT to FLASH
void EEsim_Read(char*);                   // Fill STRUCT with FLASH data


