/*
  test program for EEsim; Write / Read a STRUCT into FLASH
  tested on dsPIC33FJ with 256K FLASH
  look at header file for 128K / 64K versions
*/

#include "EEsim.h"    // header file

/*
  this is the struct that holds the non-volatile data needed
  on power-on; like calibration data, user ID's, model& serial #'s
*/
struct T{
  long a;
  long aa;
  long aaa;
  int p;
  int pp;
  int ppp;
  char ary[100];
};
struct T test;

// variables
long ii;
long res,lBlock;
void * pv1;

// MAIN
void main() {
  unsigned i, k;
  // PLL settings
  PLLPRE_4_bit = 0;                  // PLLPRE<4:0> = 0  ->  N1 = 2    8MHz / 2 = 4MHz
  PLLPRE_3_bit = 0;                  // (must be within 0.8 MHz to 8 MHz range)
  PLLPRE_2_bit = 0;
  PLLPRE_1_bit = 0;
  PLLPRE_0_bit = 0;
  PLLFBD =   38;                     // PLLDIV<8:0> = 38 ->  M = 40    4MHz * 40 = 160MHz
                                     // (must be within 100 MHz to 200 MHz range)
  PLLPOST_0_bit = 0;                 // PLLPOST<1:0> = 0 ->  N2 = 2    160MHz / 2 = 80MHz
  PLLPOST_0_bit = 0;                 // (must be within 12.5 MHz to 80 MHz range)
  AD1PCFGL = 0xFFFF;
  AD1PCFGH = 0xFFFF;
  AD2PCFGL = 0xFFFF;

  // set values
  test.a = 0xDADA;
  test.aa = 0xEAEA;
  test.aaa = 0xBABA;
  test.p = 0xCD;
  test.pp = 0xCC;
  test.ppp = 0xABC;                   // easy to find in debugger
  for(ii=0; ii<100; ii++)
  {
      test.ary[ii]=0xAA;
  }
  //
  EEsim_Init();                       // init EEsim
  pv1 = &test;
  EEsim_Write(pv1,sizeof test);       // write STRUCT to FLASH
  asm nop;
  asm nop;
  test.a = 0xAAAA;                    // change data in STRUCT
  test.aa = 0xBBBB;                   // so we can verify it was returned
  test.aaa = 0xCCCC;                  // to orig values after the READ
  for(ii=0; ii<100; ii++)
  {
      test.ary[ii]=0xDE;
  }
  asm nop;                            // CHECK THAT STRUCT DATA CHANGED
                                      // IN DEBUGGER
  pv1 = &test;
  EEsim_Read(pv1);                    // read data from FLASH into STRUCT
  asm nop;
  asm nop;                            // CHECK THAT STRUCT DATA CHANGED
                                      // IN DEBUGGER
}